//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   26 Dec 05  Brian Frank  Creation
//   19 Aug 06  Brian Frank  Ported from Java to Fan
//

**
** FSlot is the read/write fcode representation of sys::Slot.
**
class FSlot : FConst
{

//////////////////////////////////////////////////////////////////////////
// IO
//////////////////////////////////////////////////////////////////////////

  protected Void writeCommon(OutStream out)
  {
    out.writeI2(name)
    out.writeI4(flags & FlagsMask)
  }

  protected Void readCommon(InStream in)
  {
    name  = in.readU2
    flags = in.readU4
  }

  protected Void writeFacets(OutStream out)
  {
    if (facets == null)
    {
      out.writeI2(0)
    }
    else
    {
      out.writeI2(facets.size)
      facets.each |FFacet f| { f.write(out) }
    }
  }

  protected Void readFacets(InStream in)
  {
    size := in.readU2
    if (size === 0)
    {
      facets = FFacet[,]
    }
    else
    {
      f := facets = FFacet[,]
      size.times |,| { f.add(FFacet.make.read(in)) }
    }
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  Int name          // name index
  Int flags         // bitmask
  FFacet[] facets   // meta-data

}