//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   02 Jul 06  Andy Frank  Creation
//

using web

**
** FandocSearch.
**
class FandocSearch : FandocWeblet
{

//////////////////////////////////////////////////////////////////////////
// Weblet
//////////////////////////////////////////////////////////////////////////

  override Void get()
  {
    q := req.uri.query["q"].lower
    m := Type[,]

    // Try to find exact match
    pods := Pod.list
    for (i:=0; i<pods.size; i++)
    {
      pods[i].types.each |Type type|
      {
        if (q == type.name.lower)
          m.push(type)
      }
    }

    // If only a single match, redirect directly to match
    if (m.size == 1)
    {
      t := m.first
      res.redirect(302, "$t.pod/$t.name".toUri)
      return
    }

    doHeader("Search Results - Fandoc")

    if (m.isEmpty)
    {
      // If no matches found
      out.h1("No matches found for ${q}")
    }
    else
    {
      // List possible matches
      out.h1("Possible matches for ${q}")
      out.ul
      m.each |Type t|
      {
        out.li.a(typeUri(t)).w(t.qname).aEnd.nl.liEnd
      }
      out.ulEnd
    }

    doFooter()
  }

}