//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   05 Apr 06  Andy Frank  Creation
//

using web

**
** FandocSrc.
**
class FandocSrc : FandocWeblet
{

//////////////////////////////////////////////////////////////////////////
// Weblet
//////////////////////////////////////////////////////////////////////////

  override Void get()
  {
    pod  := (Pod)req.stash["pod"]
    type := (Type)req.stash["type"]

    doHeader("Source for $type.name - Fandoc")

    out.div("class='header'")
    out.table("width='100%' cellspacing='0' cellpadding='0'")
    out.tr

    out.td
    doBreadcrumb(pod, type, true)
    out.tdEnd

    out.td("style='text-align: right;'")
    doSearch()
    out.tdEnd

    out.trEnd
    out.tableEnd
    out.divEnd

    out.div("class='content'")
    out.div("class='tabs'")
    out.a(typeUri(type)).w("Fandoc").aEnd
    out.w(" ").span("class='sep'").w("|").spanEnd.w(" Source")
    out.divEnd
    out.h1(type.toStr)
    out.hr

    out.div("class='source'")
    file := pod.files["/src/$type.sourceFile".toUri]
    FanToHtml.convert(file.in.readAllLines, out)
    out.divEnd

    out.divEnd

    doFooter
  }

}

