//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   4 Jan 06  Brian Frank  Creation
//
package fan.sys;

/**
 * MethodParam represents one formal parameter to a Method.
 */
public class MethodParam
  extends FanObj
{

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////

  public MethodParam(Str name, Type paramType, int mask)
  {
    this.name      = name;
    this.paramType = paramType;
    this.mask      = mask;
  }

//////////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////////

  public Type type() { return Sys.MethodParamType; }

  public Str name()        { return name; }
  public Type paramType()  { return paramType; }
  public Bool hasDefault() { return Bool.make(mask & HAS_DEFAULT); }

  public Str toStr() { return Str.make(paramType + " " + name); }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public static final int HAS_DEFAULT   = 0x01;  // is a default value provided

  final Str name;
  final Type paramType;
  final int mask;

}