//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Mar 06  Brian Frank  Creation
//
package fan.sys;

/**
 * OutStream interface.
 */
public interface OutStream
{

  public OutStream w(int b);

  public OutStream write(Int x);

  public OutStream writeBuf(Buf buf);
  public OutStream writeBuf(Buf buf, Int n);

  public OutStream writeI2(Int x);

  public OutStream writeI4(Int x);

  public OutStream writeI8(Int x);

  public OutStream writeF4(Float x);

  public OutStream writeF8(Float x);

  public OutStream writeBool(Bool x);

  public OutStream writeUtf(Str x);

  public Charset charset();
  public void charset(Charset charset);

  public OutStream writeChar(Int c);

  public OutStream writeChars(Str s);
  public OutStream writeChars(Str s, Int off);
  public OutStream writeChars(Str s, Int off, Int len);

  public OutStream print(Obj s);

  public OutStream printLine();
  public OutStream printLine(Obj s);

  public OutStream writeProps(Map props);
  public OutStream writeProps(Map props, Bool close);

  public void flush();

  public Bool close();

}