//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   19 Sep 06  Brian Frank  Creation
//
package fan.sys;

/**
 * Weekday
 */
public class Weekday
  extends Enum
{

  public static final Weekday sun = new Weekday(0, "sun");
  public static final Weekday mon = new Weekday(1, "mon");
  public static final Weekday tue = new Weekday(2, "tue");
  public static final Weekday wed = new Weekday(3, "wed");
  public static final Weekday thu = new Weekday(4, "thu");
  public static final Weekday fri = new Weekday(5, "fri");
  public static final Weekday sat = new Weekday(6, "sat");

  public static final List values;
  static
  {
    List v = new List(Sys.WeekdayType, 7);
    v.add(sun).add(mon).add(tue).add(wed).add(thu).add(fri).add(sat);
    values = v.ro();
  }

  private Weekday(int ordinal, String name)
  {
    Enum.make$(this, Int.pos[ordinal], Str.make(name).intern());
  }

  public Type type() { return Sys.WeekdayType; }

}