//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   15 Sep 05  Brian Frank  Creation
//
package fanx.compiler;

/**
 * ILocation provides a source file, line number, and column number.
 */
public interface ILocation
{

  /**
   * Source file - should be absolute String filepath or canonical File
   */
  public Object file();

  /**
   * Line number or 0 if unknown
   */
  public int line();

  /**
   * Column number or 0 if unknown
   */
  public int col();

  /**
   * Format as standard string.
   */
  public String format();

}