//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   5 Mar 06  Brian Frank  Creation
//
package fanx.compiler.ast;

import fanx.compiler.*;

/**
 * NopStmt is a place holder for a null statement.
 */
public class NopStmt
  extends Stmt
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public NopStmt(ILocation location)
  {
    super(location);
  }

//////////////////////////////////////////////////////////////////////////
// Stmt
//////////////////////////////////////////////////////////////////////////

  public int id()
  {
    return NOP;
  }

//////////////////////////////////////////////////////////////////////////
// Debug
//////////////////////////////////////////////////////////////////////////

  public String toString()
  {
    return "nop";
  }

  public void tree(AstWriter out)
  {
    out.w("NopStmt").nl();
  }

  public void pretty(AstWriter out)
  {
    out.w("nop;").nl();
  }

}