//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   15 Sep 05  Brian Frank  Creation
//
package fanx.compiler.ast;

import fan.sys.*;
import fanx.compiler.*;

/**
 * ThisExpr puts the implicit this pointer on the stack.
 */
public class ThisExpr
  extends LocalVarExpr
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public ThisExpr(ILocation location)
  {
    super(location);
  }

//////////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////////

  public int register()
  {
    return 0;
  }

  public int id()
  {
    return THIS;
  }

  public String toString()
  {
    return "this";
  }

}