//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   26 Dec 05  Brian Frank  Creation
//
package fanx.fcode;

import java.io.*;
import java.util.*;

/**
 * FMethodVar models one parameter or local variable in a FMethod
 */
public class FMethodVar
  implements FConst
{

//////////////////////////////////////////////////////////////////////////
// Flags
//////////////////////////////////////////////////////////////////////////

  public boolean isParam()     { return (flags & Param)     != 0; }

//////////////////////////////////////////////////////////////////////////
// IO
//////////////////////////////////////////////////////////////////////////

  public void write(FStore.Output out) throws IOException
  {
    out.u2(name);
    out.u2(type);
    out.u1(flags);
    FBuf.write(out, def);
  }

  public FMethodVar read(FStore.Input in) throws IOException
  {
    name  = in.u2();
    type  = in.u2();
    flags = in.u1();
    def   = FBuf.read(in);
    return this;
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public int name;      // str index
  public int type;      // type qname index
  public int flags;     // method variable flags
  public FBuf def;      // default expression or null (only for params)

}