//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fan.Sys
{
  /// <summary>
  /// Field is a slot which "stores" a value.
  /// </summary>
  public class Field : Slot
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    public Field(Type parent, Str name, int flags, Facets facets, Type fieldType)
      : base(parent, name, flags, facets)
    {
      this.fieldType = fieldType;
    }

  //////////////////////////////////////////////////////////////////////////
  // Signature
  //////////////////////////////////////////////////////////////////////////

    public override Type Type()  { return Sys.FieldType;  }

    public Type FieldType() { return fieldType; }

    public Method Getter() { return getter; }

    public Method Setter() { return setter; }

    public override Str Signature() { return Str.Make(fieldType.ToStr().val + " " + Str.Make(name.val)); }

  //////////////////////////////////////////////////////////////////////////
  // Reflection
  //////////////////////////////////////////////////////////////////////////

    /*
    public Obj Get() { return get(null); }
    public Obj Get(Obj instance)
    {
      if (getter != null)
      {
        return getter.invoke(instance, (Object[])null);
      }

      try
      {
        parent.finish();
        return (Obj)reflect.get(instance);
      }
      catch(Exception e)
      {
        if (reflect == null)
          throw Err.make("Field not mapped to java.lang.reflect correctly").val;

        throw Err.make(e).val;
      }
    }

    public void set(Obj instance, Obj value)
    {
      if (setter != null)
      {
        setter.invoke(instance, new Obj[] { value });
        return;
      }

      try
      {
        parent.finish();
        reflect.set(instance, value);
      }
      catch(Exception e)
      {
        if (reflect == null)
          throw Err.make("Field not mapped to java.lang.reflect correctly").val;

        throw Err.make(e).val;
      }
    }
    */

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    internal readonly Type fieldType;
    internal Method getter;
    internal Method setter;
    //java.lang.reflect.Field reflect;

  }
}