//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fan.Sys
{
  /// <summary>
  /// IOErr.
  /// </summary>
  public class IOErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static IOErr Make(string msg)  { return Make(Str.Make(msg)); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static IOErr Make() { return Make((Str)null, (Err)null); }
    public new static IOErr Make(Str msg) { return Make(msg, null); }
    public new static IOErr Make(Str msg, Err cause)
    {
      IOErr err = new IOErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(IOErr self) { Make_(self, null);  }
    public static void Make_(IOErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(IOErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // C# Constructors
  //////////////////////////////////////////////////////////////////////////

    public IOErr(Err.Val val) : base(val) {}
    public IOErr() : base(new IOErr.Val()) {}
    public IOErr(Exception actual) : base(new IOErr.Val(), actual) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.IOErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - C# Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}