//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   24 Sep 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fan.Sys
{
  /// <summary>
  /// UnknownPodErr
  /// </summary>
  public class UnknownPodErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownPodErr Make(string msg)  { return Make(Str.Make(msg)); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownPodErr Make() { return Make((Str)null, (Err)null); }
    public new static UnknownPodErr Make(Str msg) { return Make(msg, null); }
    public new static UnknownPodErr Make(Str msg, Err cause)
    {
      UnknownPodErr err = new UnknownPodErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(UnknownPodErr self) { Make_(self, null);  }
    public static void Make_(UnknownPodErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(UnknownPodErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // C# Constructors
  //////////////////////////////////////////////////////////////////////////

    public UnknownPodErr(Err.Val val) : base(val) {}
    public UnknownPodErr() : base(new UnknownPodErr.Val()) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.UnknownPodErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - C# Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}