//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   19 Oct 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fan.Sys
{
  /// <summary>
  /// UnsupportedErr
  /// </summary>
  public class UnsupportedErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static UnsupportedErr Make(string msg)  { return Make(Str.Make(msg)); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static UnsupportedErr Make() { return Make((Str)null, (Err)null); }
    public new static UnsupportedErr Make(Str msg) { return Make(msg, null); }
    public new static UnsupportedErr Make(Str msg, Err cause)
    {
      UnsupportedErr err = new UnsupportedErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(UnsupportedErr self) { Make_(self, null);  }
    public static void Make_(UnsupportedErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(UnsupportedErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // C# Constructors
  //////////////////////////////////////////////////////////////////////////

    public UnsupportedErr(Err.Val val) : base(val) {}
    public UnsupportedErr() : base(new UnsupportedErr.Val()) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.UnsupportedErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - C# Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}