//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fanx.Fcode
{
  /// <summary>
  /// FBuf stores a byte buffer (such as executable fcode, or line numbers).
  /// </summary>
  public class FBuf
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructors
  //////////////////////////////////////////////////////////////////////////

    //public FBuf(Box box)
    //{
    //  this.buf = box.buf;
    //  this.len = box.len;
    //}

    public FBuf(byte[] buf, int len)
    {
      this.buf = buf;
      this.len = len;
    }

  //////////////////////////////////////////////////////////////////////////
  // Utils
  //////////////////////////////////////////////////////////////////////////

    public int U2()
    {
      return buf[0] << 16 | buf[1];
    }

    public string Utf()
    {
      // TODO - is this actually correct?
      BinaryReader r = new BinaryReader(new MemoryStream(buf));
      return new string(r.ReadChars(len));
    }

  //////////////////////////////////////////////////////////////////////////
  // IO
  //////////////////////////////////////////////////////////////////////////

    public static FBuf Read(FStore.Input input)
    {
      int len = input.U2();
      if (len == 0) return null;

      byte[] buf = new byte[len];
      //input.ReadFully(buf, 0, len);
      // TODO
      input.Read(buf, 0, len);

      return new FBuf(buf, len);
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    public byte[] buf;
    public int len;

  }
}