//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fanx.Fcode
{
  /// <summary>
  /// FFacet is meta-data for a FType of FSlot.
  /// </summary>
  public class FFacet
  {
    public FFacet(int name, int flags, FBuf data)
    {
      this.name  = name;
      this.flags = flags;
      this.data  = data;
    }

    public FFacet()
    {
    }

    public static FFacet Facet(FPod pod, FFacet[] facets, string name)
    {
      if (facets != null)
      {
        for (int i=0; i<facets.Length; i++)
          if (pod.Name(facets[i].name) == name)
            return facets[i];
      }
      return null;
    }

    public FFacet Read(FStore.Input input)
    {
      name = input.U2();
      flags = input.U1();
      data = FBuf.Read(input);
      return this;
    }

    public static FFacet[] None = new FFacet[0];

    public int name;    // name index
    public int flags;
    public FBuf data;
  }
}